



<!DOCTYPE html><html lang=zh-CN><head><meta http-equiv="Content-Type" content="text/html; charset=utf-8" /><meta http-equiv="X-UA-Compatible" content="IE=edge,chrome=1"><meta name="applicable-device" content="pc,mobile"><meta name="renderer" content="webkit"><meta name="viewport" content="width=device-width,initial-scale=1.0,maximum-scale=5,viewport-fit=cover">
<title>Python之ftp服务器</title>	
<script src="//n4.ikafan.com/assets/run_prettify.js?ac"></script>
<link rel="stylesheet" href="//n4.ikafan.com/assetsg/style.css">
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/fontello.css?ac"> -->
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/animation.css?ac"> -->
<script>
var _hmt = _hmt || [];
(function() {
  var hm = document.createElement("script");
  hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
  var s = document.getElementsByTagName("script")[0]; 
  s.parentNode.insertBefore(hm, s);
})();
</script>
<script src="https://n4.ikafan.com/g/show.js"></script>

</head>
<div id="header" class="navbar navbar-default navbar-fixed-top header-01">
	<div class="container">
		<h1 class="logo">
			<a  href="/" title="巴特西"/>
							巴特西
			</a>
		</h1>
				<div role="navigation"  class="site-nav  primary-menu">
			<div class="menu-fix-box">
				 <ul id="menu-navigation" class="menu" >
<li><a href="/">首页</a></li>
<!-- <li><a href="/search/Hadoop/">Hadoop</a></li>
<li><a href="/search/Linux/">Linux</a></li>
<li><a href="/search/jQuery/">jQuery</a></li> -->
<li><a href="/search/Python/">Python</a></li>
<li><a href="/search/Java/">Java</a></li>
<li><a href="/search/PHP/">PHP</a></li>
<li><a href="/search/IOS/">IOS</a></li>
<li><a href="/search/Andorid/">Andorid</a></li>
<li><a href="/search/NodeJS/">NodeJS</a></li>
<li><a href="/search/JavaScript/">JavaScript</a></li>
<li><a href="/search/HTML5/">HTML5</a></li>
				</ul>					 			
			</div>
		</div>
				<!--<div class="right-nav">
				<button class="js-toggle-search"><i class="icon-search"></i></button>
		</div>-->
       
			</div>	
</div>

<div id="page-content">
	<div class="container">
		<div class="row">
			
			<div class="blog-post">
								<!--<div class="posts-top-cjtz clearfix"></div>-->
								<div class="post">
										<div class="post-title">
											<div id="title_top"></div>
<script>insertAdIfNeeded();</script>
						<h1 class="title">Python之ftp服务器</h1>
						<div class="post_icon">
							<span class="icon-clock-1"> 2024-03-23 11:13:20 </span>
						</div>
										<div class="post-content">
													<div id="single_top"></div>
<script>insertAdIfNeeded();</script>
											
		<p>今天把做的ftp服务器过程总结一下，先看看要求</p>
<p>一.需求</p>
<p>1. 用户加密认证</p>
<p>2. 允许同时多用户登录</p>
<p>3. 每个用户有自己的家目录 ，且只能访问自己的家目录</p>
<p>4. 对用户进行磁盘配额，每个用户的可用空间不同</p>
<p>5. 允许用户在ftp server上随意切换目录cd</p>
<p>6. 允许用户查看当前目录下文件ls</p>
<p>7. 允许上传put和下载get文件，保证文件一致性</p>
<p>8. 文件传输过程中显示进度条</p>
<p>附加实现的功能：</p>
<p>1.实现服务器端文件删除，创建、删除目录</p>
<p>2.查看当前账户状态</p>
<p>3.实现断点续传</p>
<p>二.实现过程解析</p>
<p>1.客户端在登录的时候，密码不能用明文，以保证连接的安全性。以我现在的水平也就是把密码用hashlib里的md5转成密文一下。不过这个过程可以最后在做，前期调试过程可以用明文。</p>
<p>2.a使用socketserver做多并发来保证多个用户同时登录。我在<a href="https://www.cnblogs.com/yinsedeyinse/p/10230825.html" rel="external nofollow noreferrer">socketserver</a>里演示了socketserver的多并发的使用。</p>
<p>b在服务器端db文件夹内存有各个账户的文件。文件用josn的格式存储了账户的信息。</p>
<div>
<pre class="prettyprint linenums">{"user_id":"admin","password":"","totle_space":100000000,"stat":false}</pre>
</div>
<p>c账户内有个key：used_space是每次登陆时候生成的，在每次put操作和rmdir/remove后都会重新获取已用空间的值。最初用的是os.stat().st_size获取，但获取不到文件夹的占用空间。做了个这样的函数</p>
<div>
<div>
<pre class="prettyprint linenums"> def get_path_size(self,path):<br />
     size = 0<br />
     for root, dirs, files in os.walk(path):<br />
         for f in files:<br />
             size += os.path.getsize(os.path.join(root, f))<br />
     return size</pre>
</div>
<p>get_size</p></div>
<p>用这个方法，在文件量比较大的时候效率会比较低，高效的方法还没想好，看看以后还能改不！</p>
<p>3.在服务器端有个User的文件夹，文件夹内有各个用户的子文件夹。用户可以在客户端内进行目录的切换。这里是个很重要的地方：</p>
<p>a.用os.popen或者os.system()来执行cd的指令，是个深坑(特别是在linux内，一运行，就重新启动个terminal，然后就关闭了）</p>
<p>b.如果用chdir()的话，其实是改变了socketserver的工作目录，要是chdir('root')就相当有了root用户的权利，绝对不能用。</p>
<p>c.所以要切换目录，也就是不能切换，我在cmd的字典里加了个user_path的值，put、get都是在这个目录下进行的</p>
<p>d.每次登录后，直接进入该用户的路径:，每次用cd切换路径时，改变cmd_dic['user_path']的值。，刚好cd后有个空格，把空格后的字符赋值给cmd_dic['filename'],在服务器端根据这个值是'..'还是具体的路径进行相对应的操作。</p>
<p>e.在进行cd..时，应该注意最终只能到用户的家目录下。</p>
<p>f.在用os.popen('ls').read()时，返回的是该运行的.py所在文件夹下的文件，应该加上cmd_dic['user_path']的路径。</p>
<p>4.在conf文件夹下把所有的指令集做一个文件。把所有的操作对应的指令都存在这个文件内。这个指令集应该在服务器端，在登陆后发送给客户端。（这个暂未实现）</p>
<p>5.在实现put功能时，用了tkinter.filedialog弹窗选择文件的功能。</p>
<div>
<div>
<pre class="prettyprint linenums"> import tkinter.filedialog<br />
 file = tkinter.filedialog.askopenfilename()<br />
 print(file)</pre>
</div>
<p>弹窗选择文件</p></div>
<p>打印输出的就是文件的路径，但是有个问题还不知道原因，这里获取的文件路径的分隔符用的是'/'（系统是windows）。</p>
<div>
<div>
<pre class="prettyprint linenums">C:\Users\Aaron\AppData\Local\Continuum\anaconda3\python.exe D:/python/homework/homework_ftp/ftp_client/test.py<br />
C:/Users/Aaron/Desktop/UnderstandingGIL.pdf<br />
注意下方的运行结果，文件分隔符用的是'/'<br />
Process finished with exit code 0</pre>
</div>
<p>运行结果</p></div>
<p>还有，这个tkiner的对话框在pycharm内单独调试的过程没什么问题，但是放在客户端的代码内每次运行完对话框不自行关闭，手动关闭就会卡死然后报出python未响应的错误（不关闭程序倒是能正常运行）在terminal内也不行。在不知道是不是库里的文件有问题。</p>
<p>6.在显示进度条的时候，思路是这样的：</p>
<p>a.由于每次发送接收都是逐行发送的，就会有filesize和receivedsize，两个一除，在乘100后取整就好（当时忘记了&times;100，由于是个百分数取整以后一直都是0）</p>
<p>　　　 b.进度条显示是这样的</p>
<div>
<div>
<pre class="prettyprint linenums"> import sys,time<br />
 for i in range(50):<br />
     sys.stdout.write("#")<br />
     sys.stdout.flush()<br />
     time.sleep(0.1)</pre>
</div>
<p>进度条</p></div>
<p>　　　　c.如果在每次接收时都显示一遍进度，会有很多重复的数据，我做了个判断，如果进度变化，就flush一遍，否则不再输出。</p>
<p>三.文件结构</p>
<p><img referrerpolicy="no-referrer"src="https://img2018.cnblogs.com/blog/1415597/201902/1415597-20190213184838325-1263366077.png" /></p>
<p>程序分为上图中的结构，其实core中的main里涵盖了几乎所有的功能，功能多了以后在修改时候过于繁琐，其实应该把各个功能封装好另存在core文件夹下，再导入到main中（主要时偷懒了，因为开始写程序的时候是第一个功能就是写在main里的，后面就没改）。</p>
<p>后期可以更改的部分：</p>
<p>1.把main程序分解</p>
<p>2.改进进度条的显示</p>
<p>3.修改tkiner的对话框卡死的bug</p>
<p>4.把指令集放在server端</p>
<p>最后，把项目的代码放在云盘上了！<a href="https://pan.baidu.com/s/146ZmIYRkE3zk1h14-AtMiw" rel="external nofollow noreferrer">代码地址</a>，提取码：fvso</p>												<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
																
<h2>最新文章</h2>	
<ol>
						<li><a href="https://www.batexi.com/a/o8o52lp9.html">解决ViewPager多次刷新后重叠问题</a>
		</li>
						<li><a href="https://www.batexi.com/a/m8z3pexq.html">Web 项目中分享到微博、QQ空间等分享功能</a>
		</li>
						<li><a href="https://www.batexi.com/a/rqlgo6k9.html">c&plus;&plus; 标准库的各种容器&lpar;vector&comma;deque&comma;map&comma;set&comma;unordered&lowbar;map&comma;unordered&lowbar;set&comma;list&rpar;的性能考虑</a>
		</li>
						<li><a href="https://www.batexi.com/a/m8z533v8.html">②springMVC入门</a>
		</li>
						<li><a href="https://www.batexi.com/a/q4yyod3q.html">ZOJ 3826</a>
		</li>
						<li><a href="https://www.batexi.com/a/9rd55ke8.html">Hive&lpar;一&rpar;&colon;架构及知识体系</a>
		</li>
						<li><a href="https://www.batexi.com/a/qlmpggk9.html">常用 Unicode 符号列表</a>
		</li>
						<li><a href="https://www.batexi.com/a/qvv75vjq.html">别名的应用（New-Alias）</a>
		</li>
						<li><a href="https://www.batexi.com/a/qxn46608.html">Extjs3 Combo实现百度搜索查询</a>
		</li>
						<li><a href="https://www.batexi.com/a/qxk5xdz8.html">HTTP权威指南-HTTP概述</a>
		</li>
						<li><a href="https://www.batexi.com/a/qnvv36k8.html">46&period;Linux-分析rc红外遥控平台驱动框架&comma;修改内核的NEC解码函数BUG&lpar;1&rpar;</a>
		</li>
						<li><a href="https://www.batexi.com/a/9r5m52mq.html">搭建SSH服务</a>
		</li>
						<li><a href="https://www.batexi.com/a/8kon7n6q.html">highcharts PHP中使用</a>
		</li>
						<li><a href="https://www.batexi.com/a/963lno39.html">windows安装及配置mysql5&period;7</a>
		</li>
						<li><a href="https://www.batexi.com/a/8zkljld8.html">svn提交失败  ：&OpenCurlyDoubleQuote;svn&colon; E200007&colon; Commit failed&rdquo;</a>
		</li>
						<li><a href="https://www.batexi.com/a/q1vnj4zq.html">解决 maven 项目启动 提示 class not find</a>
		</li>
						<li><a href="https://www.batexi.com/a/qx2ry7z8.html">Drupal的&dollar;messages是怎么显示的？</a>
		</li>
						<li><a href="https://www.batexi.com/a/9pp6l3y9.html">《转》python学习--基础下</a>
		</li>
						<li><a href="https://www.batexi.com/a/8e0erxjq.html">【纯代码】Swift-自定义PickerView单选（可修改分割线颜色、修改字体大小、修改字体颜色。）（可根据需要自己扩展）</a>
		</li>
						<li><a href="https://www.batexi.com/a/q44yyr3q.html">jquery&period;lazyload&period;js 图片延迟加载</a>
		</li>
		</ol>
	

<h2>热门文章</h2>	
<ol>
									<li><a href="https://www.batexi.com/a/q25go4xq.html">JS基础&mdash;&mdash;变量</a>
			</li>
						<li><a href="https://www.batexi.com/a/qnvg3pj8.html">MyISAM与InnoDB两者之间区别与选择，详细总结，性能对比</a>
			</li>
						<li><a href="https://www.batexi.com/a/qv235m19.html">a&period;vim 插件</a>
			</li>
						<li><a href="https://www.batexi.com/a/8e4r11z9.html">JavaScript获取、修改CSS样式合辑</a>
			</li>
						<li><a href="https://www.batexi.com/a/8e4r1kj9.html">leetcode42</a>
			</li>
						<li><a href="https://www.batexi.com/a/90rkm7n9.html">viewDidLoad&comma; viewWillDisappear&comma; viewWillAppear等区别及各自的加载顺序</a>
			</li>
						<li><a href="https://www.batexi.com/a/8e4ryzx9.html">source tree常用功能</a>
			</li>
						<li><a href="https://www.batexi.com/a/960z01n9.html">java&period;util&period;HashSet&comma; java&period;util&period;LinkedHashMap&comma; java&period;util&period;IdentityHashMap 源码阅读 &lpar;JDK 1&period;8&period;0&lowbar;111&rpar;</a>
			</li>
						<li><a href="https://www.batexi.com/a/9j1dmpe9.html">a链接的onclick与js中的return false</a>
			</li>
						<li><a href="https://www.batexi.com/a/q1rwv328.html">tesseract编译错误：fatal error&colon; allheaders&period;h&colon; No such file or directory</a>
			</li>
			</ol>			
							
					</div>

					
<div class="next-prev-posts clearfix">
</div>
						 
				</div>
				
	<div class="clear"></div>

			</div>	
			

		</div>
</div>
</div>


<div class="clearfix"></div>
<div id="footer" class="two-s-footer">
	<div class="footer-box">
		<div class="container">
			<div class="row" style="padding-left: 15px;padding-right: 15px;">
			<div class="nav-footer">
				<a href="/">Home</a>
				</div>
				<div class="copyright-footer">
					<p>Powered By WordPress</p>
				</div>
							</div>
		</div>
	</div>
</div>
<div style="display:none">

</div>
<script src="//n4.ikafan.com/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
 </script>
</body>
</html>
